#!/usr/bin/perl -w
# (c) Copyright 2005-2007. CodeWeavers, Inc.
package CXRecodeIconv;
use strict;
use CXUtils;
use CXLog;

sub new($)
{
    my ($class)=@_;
    my $self={};
    bless $self, $class;
    return $self;
}

sub recode($$$$)
{
    return undef if (!defined $_[1]);
    my ($self, $src, $src_encoding, $dst_encoding)=@_;

    my $key=":$src_encoding:$dst_encoding:$src";
    my $dst=$self->{$key};
    if (!defined $dst)
    {
        if ($src_encoding ne $dst_encoding)
        {
            my $cmd="echo " . shquote_string($src) .
                " | iconv -f " . shquote_string($src_encoding) .
                " -t " . shquote_string($dst_encoding) . " 2>/dev/null";
            $dst=cxbackquote($cmd);
            if ($? == 0)
            {
                chomp $dst;
            }
            else
            {
                cxlog("unable to convert '$src' from $src_encoding to $dst_encoding\n");
                $dst=$src;
            }
        }
        else
        {
            $dst=$src;
        }
        $self->{$key}=$dst;
    }
    return $dst;
}

sub to_sys($$$)
{
    my ($self, $src_encoding, $src)=@_;
    return $self->recode($src, $src_encoding, CXUtils::get_system_encoding());
}

sub from_sys($$$)
{
    my ($self, $dst_encoding, $src)=@_;
    return $self->recode($src, CXUtils::get_system_encoding(), $dst_encoding);
}

return 1;
