#!/usr/bin/perl -w
# (c) Copyright 2005. CodeWeavers, Inc.
package CXRecodePerl;
use strict;
use Encode ();
use CXUtils;
use CXLog;

sub new($)
{
    my ($class)=@_;
    my $self={};
    bless $self, $class;
    return $self;
}

sub recode($$$$)
{
    return undef if (!defined $_[1]);
    my ($self, $src, $src_encoding, $dst_encoding)=@_;

    eval { Encode::from_to($src, $src_encoding, $dst_encoding, 1) };
    if ($@)
    {
        cxlog("unable to convert '$src' from $src_encoding to $dst_encoding\n");
        $src=$_[1];
    }
    return $src;
}

sub to_sys($$$)
{
    my ($self, $src_encoding, $src)=@_;
    return $self->recode($src, $src_encoding, CXUtils::get_system_encoding());
}

sub from_sys($$$)
{
    my ($self, $dst_encoding, $src)=@_;
    return $self->recode($src, CXUtils::get_system_encoding(), $dst_encoding);
}

return 1;
